Loading...
Searching...
No Matches
Opm::BlackOilBioeffectsModule< TypeTag, enableBioeffectsV > Class Template Reference

Contains the high level supplements required to extend the black oil model by bioeffects. More...

`#include <blackoilbioeffectsmodules.hh>`

## Static Public Member Functions

static void | setParams (BlackOilBioeffectsParams< Scalar > &&params)
| Set parameters.
static void | registerParameters ()
| Register all run-time parameters for the black-oil bioeffects module.
static void | registerOutputModules (Model &model, Simulator &simulator)
| Register all bioeffects specific VTK and ECL output modules.
static bool | eqApplies (unsigned eqIdx)
static Scalar | eqWeight (unsigned eqIdx)
template<class LhsEval>
static void | addStorage (Dune::FieldVector< LhsEval, numEq > &storage, const IntensiveQuantities &intQuants)
template<class UpEval>
static void | addBioeffectsFluxes_ (RateVector &flux, unsigned phaseIdx, const Evaluation &volumeFlux, const IntensiveQuantities &upFs)
static void | applyScaling (RateVector &flux)
static void | computeFlux (RateVector &flux, const ElementContext &elemCtx, unsigned scvfIdx, unsigned timeIdx)
template<class UpstreamEval>
static void | addBioeffectsFluxes_ (RateVector &flux, const ElementContext &elemCtx, unsigned scvfIdx, unsigned timeIdx)
static void | addSource (RateVector &source, const Problem &problem, const IntensiveQuantities &intQuants, unsigned globalSpaceIdex)
static void | addSource (RateVector &source, const ElementContext &elemCtx, unsigned dofIdx, unsigned timeIdx)
static const Scalar | densityBiofilm (unsigned satnumRegionIdx)
static const Scalar | densityCalcite (unsigned satnumRegionIdx)
static const Scalar | detachmentRate (unsigned satnumRegionIdx)
static const Scalar | detachmentExponent (unsigned satnumRegionIdx)
static const Scalar | halfVelocityGrowth (unsigned satnumRegionIdx)
static const Scalar | halfVelocityUrea (unsigned satnumRegionIdx)
static const Scalar | maximumGrowthRate (unsigned satnumRegionIdx)
static const Scalar | maximumUreaUtilization (unsigned satnumRegionIdx)
static const Scalar | microbialAttachmentRate (unsigned satnumRegionIdx)
static const Scalar | microbialDeathRate (unsigned satnumRegionIdx)
static const Scalar | oxygenConsumptionFactor (unsigned satnumRegionIdx)
static const Scalar | yieldGrowthCoefficient (unsigned satnumRegionIdx)
static const Scalar | yieldUreaToCalciteCoefficient (unsigned satnumRegionIdx)
static const Scalar | bioDiffCoefficient (unsigned pvtRegionIdx, unsigned compIdx)
static const TabulatedFunction & | permfactTable (const ElementContext &elemCtx, unsigned scvIdx, unsigned timeIdx)
static const TabulatedFunction & | permfactTable (unsigned satnumRegionIdx)
static const TabulatedFunction & | pcfactTable (unsigned satnumRegionIdx)
static bool | hasPcfactTables ()

## Detailed Description

template<class TypeTag, bool enableBioeffectsV = getPropValue<TypeTag, Properties::EnableBioeffects>()>
class Opm::BlackOilBioeffectsModule< TypeTag, enableBioeffectsV >

Contains the high level supplements required to extend the black oil model by bioeffects.

The two implemented model extensions are MICP and biofilm effects in underground storage. For details on the mathematical models, refer to the OPM Flow manual.

I) MICP (Microbially Induced Calcite Precipitation) MICP is a novel and sustainable technology that leverages biochemical processes to form barriers through calcium carbonate cementation. This approach shows promise for sealing leakage zones in geological formations.

The conceptual model includes the following key mechanisms:

- Suspended microbes attach to pore walls, forming biofilm.
- A growth solution is introduced to stimulate biofilm development.
- The biofilm utilizes a cementation solution to produce calcite.
- Calcite precipitates reduce pore space, thereby decreasing rock permeability.

This implementation considers a single-phase (water) system with the following primary variables:

- Pressure of the water phase
- Concentration of suspended microbes
- Concentration of oxygen
- Concentration of urea
- Volume fraction of biofilm
- Volume fraction of calcite

II) Biofilm effects in underground applications (e.g., hydrogen storage)

Biofilm-related effects in subsurface applications such as hydrogen storage include reduced injectivity and hydrogen loss. The conceptual model includes the following mechanisms:

- Biofilm is present in the storage site prior to injection.
- The biofilm consumes injected hydrogen/CO2, leading to clogging effects.

This implementation considers a two-phase (gas + water) system with the following primary variables:

- Pressure of the gas phase
- Water saturation / dissolved gas in water
- Concentration of suspended microbes
- Volume fraction of biofilm

The documentation for this class was generated from the following file:

- opm/models/blackoil/blackoilbioeffectsmodules.hh